# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

V_3D_LOCALSTAT_METADATA = Metadata(
    id="a6bb8c497247542d7677319c765a6651871d8ea2.boutiques",
    name="3dLocalstat",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


class V3dLocalstatOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v_3d_localstat(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    outfile: OutputPathType
    """Output dataset"""


def v_3d_localstat(
    dataset: InputPathType,
    runner: Runner | None = None,
) -> V3dLocalstatOutputs:
    """
    This program computes statistics at each voxel, based on a local neighborhood of
    that voxel.
    
    Author: AFNI Team
    
    URL: https://afni.nimh.nih.gov/pub/dist/doc/program_help/3dLocalstat.html
    
    Args:
        dataset: Input dataset.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `V3dLocalstatOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V_3D_LOCALSTAT_METADATA)
    cargs = []
    cargs.append("3dLocalstat")
    cargs.append("[OPTIONS]")
    cargs.append(execution.input_file(dataset))
    ret = V3dLocalstatOutputs(
        root=execution.output_file("."),
        outfile=execution.output_file("[PREFIX].nii.gz"),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "V3dLocalstatOutputs",
    "V_3D_LOCALSTAT_METADATA",
    "v_3d_localstat",
]
