# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

V__2DWARPER_ALLIN_METADATA = Metadata(
    id="1186f25edac5de25b0b8ece18c7371b9a97b6abb.boutiques",
    name="@2dwarper.Allin",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


class V2dwarperAllinOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v__2dwarper_allin(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    reg_output: OutputPathType
    """Output registered dataset"""
    param_files: OutputPathType
    """Output registration parameter files"""


def v__2dwarper_allin(
    input_prefix: str,
    runner: Runner | None = None,
) -> V2dwarperAllinOutputs:
    """
    Perform 2D registration on each slice of a 3D+time dataset, and combine the
    results.
    
    Author: AFNI Team
    
    URL:
    https://afni.nimh.nih.gov/pub/dist/doc/program_help/@2dwarper.Allin.html
    
    Args:
        input_prefix: Prefix for the input 3D+time dataset.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `V2dwarperAllinOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V__2DWARPER_ALLIN_METADATA)
    cargs = []
    cargs.append("@2dwarper.Allin")
    cargs.append("[OPTIONS]")
    cargs.append(input_prefix)
    ret = V2dwarperAllinOutputs(
        root=execution.output_file("."),
        reg_output=execution.output_file("[OUTPUT_PREFIX]_reg+orig.HEAD"),
        param_files=execution.output_file("[OUTPUT_PREFIX]_param_*.1D"),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "V2dwarperAllinOutputs",
    "V__2DWARPER_ALLIN_METADATA",
    "v__2dwarper_allin",
]
